/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
class GMovieClip extends MovieClip
{
    public var bidsColor:Number = 0xff0000;
    
    // plot line settings
    public var _lineThick:Number = 2; // was 6
    private var _lineAlpha:Number = 100;
    
    // plot line shadow settings
    public var _shadowThick:Number = 2; // was 6
    private var _shadowDX:Number = 3;
    private var _shadowDY:Number = 3;
    private var _shadowAlpha:Number = 50;
    private var _shadowColor:Number = 0xBBBBBB;
    
    // plot points settings
    private var _pointRadius:Number = 4; // was 5
    private var _pointLineThick:Number = 2;
    private var _pointLineColor:Number = 0xFFFFFF;
    
    private function _clear(target)
    {
        target.lines_mc.clear();
        target.points_mc.clear();
        target.linesshadow_mc.clear();
    }
    
    private function drawLineP(p1:Array, p2:Array, lineColor:Number, target_mc)
    {
        drawLine(p1[0], p1[1], p2[0], p2[1], lineColor, target_mc);
    }
    
    private function drawLine(x1:Number, y1:Number, x2:Number, y2:Number, lineColor:Number, target_mc)
    {
        target_mc.lines_mc.moveTo(x1, y1);
        target_mc.lines_mc.lineStyle(_lineThick, lineColor, _lineAlpha);
        target_mc.lines_mc.lineTo(x2, y2);
        target_mc.linesshadow_mc.lineStyle(_shadowThick, _shadowColor, _shadowAlpha);
        target_mc.linesshadow_mc.moveTo(x1+_shadowDX, y1+_shadowDY);
        target_mc.linesshadow_mc.lineTo(x2+_shadowDX, y2+_shadowDY);
    }
    
    private function drawPointP(p:Array, lineColor:Number, target_mc)
    {
        drawPoint(p[0], p[1], lineColor, target_mc);
    }
    
    private function drawPointP2(p:Array, lineColor:Number, target_mc)
    {
        drawPoint2(p[0], p[1], lineColor, target_mc);
    }
    
    private function drawPoint(x:Number, y:Number, pointColor, target_mc)
    {
        target_mc.points_mc.lineStyle(_pointLineThick, _pointLineColor, 100);
        target_mc.points_mc.beginFill(pointColor);
        
        var c1 = _pointRadius*(Math.SQRT2-1); 
        var c2 = _pointRadius*Math.SQRT2/2; 
        
        target_mc.points_mc.moveTo(x+_pointRadius, y); 
        target_mc.points_mc.curveTo(x+_pointRadius, y+c1, x+c2, y+c2); 
        target_mc.points_mc.curveTo(x+c1, y+_pointRadius, x, y+_pointRadius); 
        target_mc.points_mc.curveTo(x-c1, y+_pointRadius, x-c2, y+c2); 
        target_mc.points_mc.curveTo(x-_pointRadius, y+c1, x-_pointRadius, y); 
        target_mc.points_mc.curveTo(x-_pointRadius, y-c1, x-c2, y-c2); 
        target_mc.points_mc.curveTo(x-c1, y-_pointRadius, x, y-_pointRadius); 
        target_mc.points_mc.curveTo(x+c1, y-_pointRadius, x+c2, y-c2); 
        target_mc.points_mc.curveTo(x+_pointRadius, y-c1, x+_pointRadius, y); 
        target_mc.points_mc.endFill();
    }
    
    private function drawPoint2(x:Number, y:Number, pointColor, target_mc)
    {
        target_mc.lineStyle(_pointLineThick, _pointLineColor, 100);
        target_mc.beginFill(pointColor);
        
        var c1 = _pointRadius*(Math.SQRT2-1); 
        var c2 = _pointRadius*Math.SQRT2/2; 
        
        target_mc.moveTo(x+_pointRadius, y); 
        target_mc.curveTo(x+_pointRadius, y+c1, x+c2, y+c2); 
        target_mc.curveTo(x+c1, y+_pointRadius, x, y+_pointRadius); 
        target_mc.curveTo(x-c1, y+_pointRadius, x-c2, y+c2); 
        target_mc.curveTo(x-_pointRadius, y+c1, x-_pointRadius, y); 
        target_mc.curveTo(x-_pointRadius, y-c1, x-c2, y-c2); 
        target_mc.curveTo(x-c1, y-_pointRadius, x, y-_pointRadius); 
        target_mc.curveTo(x+c1, y-_pointRadius, x+c2, y-c2); 
        target_mc.curveTo(x+_pointRadius, y-c1, x+_pointRadius, y); 
        target_mc.endFill();
    }
}