/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
class bidgraphic extends GMovieClip
{
	public var static_mc,animated_mc:MovieClip;
	public var pointsStatic:Array;
        public var drawPoints:Boolean = true;
	private var _lgp:Array; //Last Graphic Point 
	private var _lsp:Array; //Last STATIC Point 
	private var _elx:Number = 0; // End Line X :: Changed by external processor
	private var _animationStepsCount:Number = 10;
	private var _animationDelay:Number = 100;//ms
	private var _animationHandler;
	private var _animationStep:Number = 0;
	private var _animationNewPoint:Array; 
	private var _t:Boolean = false;
        
	public function bidgraphic()
        {
	    pointsStatic = new Array();
	    _animationNewPoint = new Array();
	    _lsp = new Array();
	    _lgp = new Array();
	}
	
	public function addStaticPoint(point)
        {
	    pointsStatic.push(point);
	    _lsp[0] = point[0];_lsp[1] = point[1];
	}
	
	public function drawStaticPoints()
        {
	    _clear(static_mc);
	    for (var i:Number=0;i<pointsStatic.length-1;i++)
            {
		drawLineP(pointsStatic[i], pointsStatic[i+1], bidsColor, static_mc);
		if (drawPoints)
                {
                    placePointP(pointsStatic[i], bidsColor, static_mc);
                }
	    }
	    _lgp[0] = pointsStatic[pointsStatic.length-1][0];
	    _lgp[1] = pointsStatic[pointsStatic.length-1][1];
	    if (drawPoints)
            {
                placePointP(pointsStatic[pointsStatic.length-1], bidsColor, static_mc);
            }
	}
	
	function placePointP(point, color, target)
        {
            if (target["bid"+point[2]] == undefined)
            {
                target.attachMovie("placeholder_mc", "pbid"+point[2], _parent._parent._parent._parent.getFreeLevel());
                target["pbid"+point[2]].addProperty("_amount", null, null);
                target["pbid"+point[2]].addProperty("_time", null, null);
            }
            drawPointP2([1,1], color, target["pbid"+point[2]]);
            
            target["pbid"+point[2]]._x = point[0];
            target["pbid"+point[2]]._y = point[1];
            target["pbid"+point[2]]._amount = point[3];
            target["pbid"+point[2]]._time = point[4];
            target["pbid"+point[2]].onRollOver = function()
            {
                _parent._parent._parent._parent._parent._parent.bidPopup(this);
            };
            target["pbid"+point[2]].onRollOut = function()
            {
                _parent._parent._parent._parent._parent._parent.bidPopout();
            };
	}
	
	public function animateNewPoint(p:Array)
	{
            if (pointsStatic.length > 0)
            {
                _animationNewPoint.push(p);
                if (_animationStep == 0)
                {
                    _animateNewPoint();
                }
            }
            else
            {
                addStaticPoint(p);
                drawStaticPoints();
            }
	}
	
	private function _animateNewPoint()
        {
	    _animationStep = 1;
	    _animationHandler = setInterval(this, "doAnimate", _animationDelay);
	}
	
	public function doAnimate()
	{
	    _lgp[1] = _lsp[1] + ((_animationNewPoint[0][1] - _lsp[1])/_animationStepsCount)*_animationStep;
	    _lgp[0] = _animationNewPoint[0][0];
	    _animationStep++;
		
	    drawAnimation();
		
	    if (_animationStep == _animationStepsCount)
            {
                addStaticPoint(_animationNewPoint.shift());
                drawStaticPoints();
                clearInterval(_animationHandler);
                _animationStep = 0;
                
                if (_animationNewPoint.length != 0)
                {
                    _animateNewPoint();
                    _animationStep = 1;
                }
                drawAnimation();
	    }
	}
	
	function drawAnimation()
	{
            _clear(animated_mc);
            if (_animationNewPoint.length != 0)
            {
                drawLineP(_lsp, _lgp, bidsColor, animated_mc);
            }
            drawLine(_lgp[0], _lgp[1], _elx, _lgp[1], bidsColor, animated_mc);
	}
	
	function setElx(val)
        {
	    _elx = val;
	    drawAnimation();
	}
}