/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
class legend extends MovieClip
{
    public var layers_mc,ds_mc,up_mc,down_mc:MovieClip;
    public var _layers:Array;
    
    // 0: don't sort, 1: lowest first, 2: highest first
    public var autosort:Number = 2; 
    public var sort_mc:MovieClip;
    
    private var sx:Number = 0;
    private var sy:Number = 0;
    private var dy:Number = 15;
    private var _showInBold:Number = 2;
    private var _autoSortLayers:Boolean = true;    
    
    public function legend()
    {
        _layers = new Array();
        up_mc.onRollOver = function()
        {
            _parent.ds_mc.onRollOver();
        }
        up_mc.onPress = function()
        {
            _parent.moveDown();
            _parent.setUpDownVis();
        }
        down_mc.onRollOver = function()
        {
            _parent.ds_mc.onRollOver();
        }
        down_mc.onPress = function()
        {
            _parent.moveUp();
            _parent.setUpDownVis();
        }        
        ds_mc._parent = this;
        ds_mc.onRollOver = function()
        {
            this._parent._autoSortLayers = false;
        }
        ds_mc.onRollOut = function()
        {
            this._parent._autoSortLayers = true;
        }
        setUpDownVis();		
    }
    
    function switchSort()
    {
        autosort = (autosort == 1) ? 2 : 1;
        sort();
        return autosort;
    }
    
    public function addBid(bid:Array)
    {
        if (!isLayerExists(bid[0]))
        {
            layers_mc.attachMovie("layer_mc", "layer"+bid[0], 2000+_layers.length);
            _layers.push(bid[0]);
            layers_mc["layer"+bid[0]].show(bid[0], _parent.chart_mc.area_mc.bids_mc["bid"+bid[0]].bidsColor);
        }
        layers_mc["layer"+bid[0]].amount = Number(bid[2]);
        sort();
    }

    function sort()
    {
        if ((_layers.length > 1) && (_autoSortLayers) && (autosort == 1))
        {
            for (var i:Number = 0; i <= _layers.length-1; i++)
            {
                if (layers_mc["layer"+_layers[i]].amount > layers_mc["layer"+_layers[i+1]].amount)
                {
                    var t:Number = _layers[i];
                    _layers[i] = _layers[i+1];
                    _layers[i+1] = t;
                }
            }              
            for (var i:Number = _layers.length; i > 0 ;i--)
            {
                if (layers_mc["layer"+_layers[i]].amount < layers_mc["layer"+_layers[i-1]].amount)
                {
                    var t:Number = _layers[i];
                    _layers[i] = _layers[i-1];
                    _layers[i-1] = t;
                }
            }
        }
        
        if ((_layers.length > 1) && (_autoSortLayers) && (autosort == 2)) 
        {
            for (var i:Number = 0; i <= _layers.length-1; i++)
            {
                if (layers_mc["layer"+_layers[i]].amount < layers_mc["layer"+_layers[i+1]].amount)
                {
                    var t:Number = _layers[i];
                    _layers[i] = _layers[i+1];
                    _layers[i+1] = t;
                }
            }               
            for (var i:Number = _layers.length; i > 0; i--)
            {
                if (layers_mc["layer"+_layers[i]].amount > layers_mc["layer"+_layers[i-1]].amount)
                {
                    var t:Number = _layers[i];
                    _layers[i] = _layers[i-1];
                    _layers[i-1] = t;
                }
            }
        }
        
        var btf = new TextFormat();
        btf.bold = true;
        var nbtf = new TextFormat();
        nbtf.bold = false;
    
        for (var i:Number = 0; (i < _showInBold) && (i < _layers.length); i++)
        {
            layers_mc["layer"+_layers[i]].label_mc.setTextFormat(btf);
            layers_mc["layer"+_layers[i]].label_mc.setNewTextFormat(btf);
        }
    
        for (var i:Number = _showInBold; i <= _layers.length-1; i++)
        {
            layers_mc["layer"+_layers[i]].label_mc.setTextFormat(nbtf);
            layers_mc["layer"+_layers[i]].label_mc.setNewTextFormat(nbtf);
        }
        redraw();
    }

    public function hideTooltip(str:String)
    {
        _parent.tooltip_mc.hideTooltip();
    }
    
    public function setUpDownVis()
    {
        if ((layers_mc._y + layers_mc._height) > ds_mc._height)
        {
            down_mc._visible = true;
        }
        else
        {
            down_mc._visible = false;
        }
        if (layers_mc._y < 0)
        {
            up_mc._visible = true;
        }
        else
        {
            up_mc._visible = false;
        }
    }

    private function redraw()
    {
        for (var i:Number = 0; i < _layers.length; i++)
        {
            layers_mc["layer"+_layers[i]]._x = sx;
            layers_mc["layer"+_layers[i]]._y = sy+dy*i;
        }
        setUpDownVis();
    }

    private function isLayerExists(id)
    {
        return layers_mc["layer"+id] != undefined;
    }
    
    private function moveUp()
    {
        layers_mc._y -= dy;
    }
    
    private function moveDown()
    {
        layers_mc._y += dy;
    }

    public function getUsername(id)
    {
        return this.layers_mc["layer"+id].username;
    }
}