/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
class tooltip extends GMovieClip
{
    public var label_mc;
    public var label2_mc;
    public var drawings_mc:MovieClip;
    
    private var x:Number = 0,y:Number = 0;
    private var sx:Number = 4,sy:Number = 4;
    private var _text:String;
    
    public function tooltip()
    {
        label_mc.tooltipText.autoSize = "right";
        label_mc.tooltipText.text = "";
        label2_mc.tooltipText.autoSize = "right";
        label2_mc.tooltipText.text = "";
        
        hideTooltip();
    }
    
    public function showText()
    {
        this.label_mc.tooltipText.autoSize = "left";
        this.label_mc.tooltipText.text = "";
        this.label_mc.tooltipText.text = _text;
        this.label_mc._x = x;
        this.label_mc._y = y;
    }
    
    private function drawBorder(fillColor, borderColor, alpha)
    {
        var dx,dy:Number;
        dy = this.label_mc.tooltipText.textHeight;
        dx = this.label_mc.tooltipText.textWidth;

        this.drawings_mc.clear();
        this.drawings_mc.lineStyle(1, borderColor, 100);
        this.drawings_mc.beginFill(fillColor);
        
        this.drawings_mc.moveTo(x-sx, y-sy);
        this.drawings_mc.lineTo(x+dx+sx, y-sy);
        this.drawings_mc.lineTo(x+dx+sx, y+dy+sy);
        this.drawings_mc.lineTo(x-sx, y+dy+sy);
        this.drawings_mc.lineTo(x-sx, y-sy);
        this.drawings_mc._alpha = alpha;
    }
    
    public function showTooltipXY(sx, sy:Number, str:String)
    {
        this._x = sx;
        this._y = sy;
        _text = str;
        showText();
        drawBorder(0xEDEFF3, 0xE1E5EB, 80);
        this.label_mc._visible = true;
    }
    
    public function hideTooltip()
    {
        this.drawings_mc.clear();
        this.label_mc._visible = false;
        this.label2_mc._visible = false;
    }
    
    function showTooltipXY2(sx:Number, sy:Number, l1:String, l2:String)
    {
        this._x = sx+1;
        this._y = sy+11;
        this.drawings_mc.clear();
        this.drawings_mc.lineStyle(3, 0x000000, 100);
        
        dashTo(-sx+50, 0, 0, 0, 5, 5);
        dashTo(0, -(_parent._real_size_y+sy-23)-1, 0, 0, 5, 5);
        
        this.label_mc._x = -sx+40;
        this.label_mc._y = 0;
        this.label2_mc._x = 0;
        this.label2_mc._y=-(_parent._real_size_y+sy-30)-1;
        
        label_mc.tooltipText.text = l1;
        label2_mc.tooltipText.text = l2;
        this.label_mc._visible = true;
        this.label2_mc._visible = true;
        this.label2_mc._x -= this.label2_mc.tooltipText.textWidth/2;
        this.label_mc._x -= this.label_mc.tooltipText.textWidth-6;
        this.label_mc._y -= this.label_mc.tooltipText.textHeight/2;
    }
    
    function dashTo(startx, starty, endx, endy, len, gap)
    {
        var seglength, deltax, deltay, segs, cx, cy, delta;
        seglength = len + gap;
        deltax = endx - startx;
        deltay = endy - starty;
        delta = Math.sqrt((deltax * deltax) + (deltay * deltay));
        segs = Math.floor(Math.abs(delta / seglength));
        var radians = Math.atan2(deltay,deltax);
        cx = startx;
        cy = starty;
        deltax = Math.cos(radians)*seglength;
        deltay = Math.sin(radians)*seglength;
        
        for (var n:Number = 0; n < segs; n++)
        {
            this.drawings_mc.moveTo(cx,cy);
            this.drawings_mc.lineTo(cx+Math.cos(radians)*len, cy+Math.sin(radians)*len);
            cx += deltax;
            cy += deltay;
        }
        
        this.drawings_mc.moveTo(cx,cy);
        delta = Math.sqrt((endx-cx)*(endx-cx)+(endy-cy)*(endy-cy));
        if (delta > len)
        {
            this.drawings_mc.lineTo(cx+Math.cos(radians)*len, cy+Math.sin(radians)*len);
        }
        else if (delta > 0)
        {
            // segment is shorter than dash so only draw required distance
            this.drawings_mc.lineTo(cx+Math.cos(radians)*delta, cy+Math.sin(radians)*delta);
        }
        this.drawings_mc.moveTo(endx, endy);
    }
}